var $ = jQuery;
var langNotChosen = '– Не выбрана –';

$(function() {

    var jSelectDiscipline = $('.SelectDiscipline');
    var jMilestone = $('.MilestoneButton');

    jSelectDiscipline.select2();
    jSelectDiscipline.val("-1");

    jMilestone.click(function() {
        var a = $(this).attr('id').split('-');
        if(jSelectDiscipline.val() != "-1")
            ChangeMilestoneForDiscipline(jSelectDiscipline.val(), a[1]);
        else
            ChangeMilestoneForAllDisciplines(a[1]);
    });

    function ChangeMilestoneForDiscipline(id, milestone)
    {
        $.post(g_URLdir + "handler/credits/setCreditMilestone/" + id + ":" + milestone);
        for(var i = 0; i < 4; i++)
        {
            $('#MilestoneTitle-' + i).css('font-weight', '');
            $('#Milestone-' + i).removeAttr('disabled');
        }
        $('#MilestoneTitle-' + milestone).css('font-weight', 'bold');
        $('#Milestone-' + milestone).attr('disabled', 'disabled');
    }

    function ChangeMilestoneForAllDisciplines(milestone)
    {
        $.post(g_URLdir + "handler/credits/setMilestone/" + milestone);
        for(var i = 0; i < 4; i++)
        {
            $('#MilestoneTitle-' + i).css('font-weight', '');
            $('#Milestone-' + i).removeAttr('disabled');
        }
        $('#MilestoneTitle-' + milestone).css('font-weight', 'bold');
    }

    function OutputDisciplineInfo(id)
    {
        $.post(
            g_URLdir + "handler/credits/getInfo",
            {
                "ID": id
            },
            function(data)
            {
                data = $.parseJSON(data);

                for(var i = 0; i < 4; i++)
                {
                    $('#MilestoneTitle-' + i).css('font-weight', 'normal');
                    $('#Milestone-' + i).removeAttr('disabled');
                }

                $('#MilestoneTitle-' + data.Milestone).css('font-weight', 'bold');
                $('#Milestone-' + data.Milestone).attr('disabled', 'disabled');


                var teachers = data.Teachers.map(function(t) { return abbreviate(t); }).join(', ');
                $('#teachersOfDiscipline').html(teachers);
            }
        );
    }

    function abbreviate(teacher) {
        return teacher.LastName + ' ' + teacher.FirstName[0] + '. ' + teacher.SecondName[0] + '.';
    }

    function GetMilestoneForCredits()
    {
        $.post(
            g_URLdir + "handler/credits/getMilestone",
            function(data)
            {
                for(var i = 0; i < 4; i++)
                {
                    $('#MilestoneTitle-' + i).css('font-weight', 'normal');
                    $('#Milestone-' + i).removeAttr('disabled');
                }
                $('#MilestoneTitle-' + data).css('font-weight', 'bold');
                $('#teachersOfDiscipline').html('---');
            }
        );
    }

    jSelectDiscipline.on('change', function() {
        if(this.value != "-1")
            OutputDisciplineInfo(this.value);
        else
            GetMilestoneForCredits();
    });
});